/*
 * John William Lynch
 * SE: 450
 * Assignment 3
 * Decorator and Chain of Responsibility pattern applied to unit conversion GUI
 * Due : March 12th, 11:59PM
 */

package Assignment3;

//Import java packages for converting to exp. notation:
import java.text.*;


/*
 * The concrete implementation of the UserDoubleDecorator Class
 * This takes in the userDouble and passes it to the userInput (which is a userDouble)
 * From there we extract the currentDouble and pass it to the exp notation
 * 
 */

public class ExpDecorator extends UserDoubleDecorator {
	//Create a decimal formatter with the exp. notation version:
	//For some reason my formatter was required to use a capital E, so I later used a replace method for a lower case e.
	NumberFormat formatter = new DecimalFormat("0.######E0");
	
	//Call the previous userInput object
	UserDouble userInput;
	
	public ExpDecorator(UserDouble userInput) {
		System.out.println("ExpDecorator hit...");
		this.userInput = userInput;
		this.userInput.doubleInput = userInput.getDouble();
		this.userInput.measureInput = userInput.getMeasureType();
	}
	
	public double getDouble() {
		return userInput.doubleInput;
	}
	
	public String getMeasureType () { 
		return userInput.measureInput;
	}
	
	public String currentDouble() {
		//Use formatter to return a modified value of currentDouble:
		//Again, to match up with the example provided in class, I use a replace method because my decimalFormat 
		//does not run properly when I have a capital E present. Therefore, I used a quick .replace method to make it a lower case e.
		//This runs fine because the conversion is done and the string is ready to be replaced, and all other functionality is present
		return formatter.format(Double.parseDouble(userInput.currentDouble())).toString().replace('E', 'e');
	}

}
