/*
 * John William Lynch
 * SE: 450
 * Assignment 3
 * Decorator and Chain of Responsibility pattern applied to unit conversion GUI
 * Due : March 12th, 11:59PM
 */
package Assignment3;

/*
 * The concrete implementation of the UserDoubleDecorator Class
 * This takes in the userDouble and passes it to the userInput (which is a userDouble)
 * From there we extract the currentDouble and format it
 * 
 */
//Decimal formatting libraries
import java.text.DecimalFormat;

public class RoundDecorator extends UserDoubleDecorator {
	//This is used with the imported class, will just create a small
	//variable that will help with converting to two decimal places.
	private static DecimalFormat df2 = new DecimalFormat("#.##");
	
	
	UserDouble userInput;
	
	public RoundDecorator(UserDouble userInput) {
		System.out.println("RoundDecorator hit...");
		this.userInput = userInput;
		this.userInput.doubleInput = userInput.getDouble();
		this.userInput.measureInput = userInput.getMeasureType();
		
	}
	
	public double getDouble() {
		return userInput.doubleInput;
	}
	
	public String getMeasureType () { 
		return userInput.measureInput;
	}
	
	public String currentDouble() {
		//use a decimal format to cut off the last two values of these
		return (df2.format(Double.parseDouble(userInput.currentDouble())).toString());
	}
}
