/*
 * John William Lynch
 * SE: 450
 * Assignment 3
 * Decorator and Chain of Responsibility pattern applied to unit conversion GUI
 * Due : March 12th, 11:59PM
 */

package Assignment3;

/*
 * The concrete implementation of the UserDoubleDecorator Class
 * This takes in the userDouble and passes it to the userInput (which is a userDouble)
 * From there we extract the currentDouble and format it by adding in the saved value 
 * from the start of the creation of value type:
 */
public class ValutaDecorator extends UserDoubleDecorator {

	UserDouble userInput;
	
	public ValutaDecorator(UserDouble userInput) {
		System.out.println("ValutaDecorator hit...");
		this.userInput = userInput;
		this.userInput.doubleInput = userInput.getDouble();
		this.userInput.measureInput = userInput.getMeasureType();
	
	}
	
	public double getDouble() {
		return userInput.doubleInput;
	}
	
	public String getMeasureType () { 
		return userInput.measureInput;
	}
	
	public String currentDouble() {
		//use a decimal format to cut off the last two values of these
		return userInput.currentDouble() + " " + userInput.getMeasureType();
	}
	
}
